/*
  xsetaseta@gmail.com
 Juan Galaz
 28/SEP/2017
 Medidor de capacidad
 Palencia / España
 */

#define _DEBUG

#include <TM1638.h>
// define a module on data pin 8, clock pin 9 and strobe pin 7
TM1638 module(8, 9, 7);

//Configuraciones de retardo
#define TESCALA1  42
#define TESCALA2  65
#define TESCALA4  63
// Capacidad propia del sistema
#define CZERO  27


#define ENTRADA1 A0


#define SALIDA1 2
#define SALIDA2 3
#define SALIDA3 4


char cadena[50];
byte escala;
unsigned  int z, z1, zz = 0;
byte keys;
long zl;


void setup()
{
  Serial.begin(9600);
  Serial.println("TM1638_Capacitor");
  Serial.println("================");
  pinMode(ENTRADA1, INPUT); //entrada  lectura 
 
  module.setupDisplay(1, 0); //luz
  module.setDisplayToString("SETA CAP", 0, 0);
  delay(1000);
  escala = 2;
}

void loop()
{
  z = 0;
  zz++; if(z>100) zz=0;


  for (z = 0; z < 800; z++)
  {
    keys = module.getButtons();
    if (keys > 0)
    {
      switch (keys)
      {
      case 1:
        escala = 1;
        break;
      case 2:
        escala = 2;
        break;
      case 4:
        escala = 4;
        break;
      }
    }
    delay(1);
  }

  module.setLEDs(escala);
  z = 0;
  switch (escala)
  {
  case 1:  //C>1uF
    impedanciaH();
    pinMode(SALIDA1, OUTPUT);  
    digitalWrite(SALIDA1, HIGH);
    while (digitalRead(ENTRADA1) == 0 )
      if (z < 65000)
      {
        z++;
        for (z1 = 0; z1 < 30; z1++);
      }
    digitalWrite(SALIDA1, LOW);
    if(z>=65000) { 
      sprintf(cadena, "HHHH    "); 
      break;
    }
    zl = z; 
    zl = (zl % TESCALA1) * 10;   
    zl /= TESCALA1;
    sprintf(cadena, "%04u.%luuF     ", z / TESCALA1, zl);
    break;
  case 2:    //C>1nF
    impedanciaH();
    pinMode(SALIDA2, OUTPUT);  
    digitalWrite(SALIDA2, HIGH);
    while ((PINC & 1) == 0) if (z < 65000) z++;
    digitalWrite(SALIDA2, LOW);
    if(z>=65000) { 
      sprintf(cadena, "HHHH    "); 
      break;
    }
    zl = z; 
    zl = (zl % TESCALA2) * 10;   
    zl /= TESCALA2;
    sprintf(cadena, "%04u.%lunF     ", z / TESCALA2, zl);
    break;
  case 4:    //c>12pF
    impedanciaH();
    pinMode(SALIDA3, OUTPUT);  
    digitalWrite(SALIDA3, HIGH);
    while ((PINC & 1) == 0) if (z < 30000) z++;
    digitalWrite(SALIDA3, LOW);
    if(z>=30000) { 
      sprintf(cadena, "HHHH    "); 
      break;
    }    
    z -= CZERO;
    if(z>65000) z=0;
    zl = z; 
    zl *= 100;    
    zl /= TESCALA4;
    sprintf(cadena, "%04lupF     ", zl);
    break;
  }

  Serial.print(zz); 
  Serial.print("  T=");   Serial.print(z); 
  Serial.print("  C="); 
  Serial.println(cadena);
  module.setDisplayToString(cadena, 0, 0);

  switch (escala)
  {
  case 1:
    digitalWrite(SALIDA1, LOW);
    break;
  case 2:
    digitalWrite(SALIDA2, LOW);
    break;
  case 4:
    digitalWrite(SALIDA3, LOW);
    break;
  }

}

//
//  AltaImpedancia
void impedanciaH(void)
{
  pinMode(SALIDA1, INPUT);
  pinMode(SALIDA2, INPUT);
  pinMode(SALIDA3, INPUT);
  digitalWrite(SALIDA1, LOW);
  digitalWrite(SALIDA2, LOW);
  digitalWrite(SALIDA3, LOW);
}
//


